var API = {
	XML_URL		: 'start.xml',
	Size		: '0',
	channels	: [ ],
	all_channels	: [ ],
	chan_counter	: 0,
	cat_counter	: 0,
	chan_pages	: 0,
	last_page_channels_counter :0,
	XHRObj		: null,
	categories	: [ ],
	loadlplaylist_timer : null,
	playlist_name	: '',
};
/* channels[]
 * 0	this.chan_counter,
 * 1	title,
 * 2	url,
 * 3	logo_30x30,
 * 4	description,
 * 5	category,
 * 6	playlist_url,
 * 7	size,
 * 8	audiotrack_num,
 * 9	buffer,
 * 10	ibuffer
 * 11	pbuffer
 */

API.init = function() {

	try {
		var fileSystemObj = new FileSystem();
		var oFile = fileSystemObj.openCommonFile('nstreamlmod_0.82.dat', 'r');
		if (oFile) {
			var url = oFile.readLine();
			if ('' != url.replace(' ', ''))
				this.XML_URL = url;
			else
				this.XML_URL = 'start.xml';

			var size = oFile.readLine();
			if (0 < size && 5 > size)
				this.Size = size;
			else if (4 < size)
				this.Size = '4';
			else
				this.Size = '0';

			fileSystemObj.closeCommonFile(oFile);
		}
	}catch (e) {
		alert('API.init Exception: ' + e);
	}

	return true;
};


API.loadplaylistTimer = function() {

	this.loadplaylist_timer = setTimeout('API.loadplaylistReturn();', 50);
};

API.loadplaylistReturn = function() {

	Display.loadinghide();
	if (this.chan_counter == 0 && Main.pl_url.indexOf('/dtv/usb/sd') == -1) {
		if (0 != this.XML_URL.indexOf('start.xml')) {
			Display.status('<b style="color:blue">ОШИБКА В СТРУКТУРЕ ПЛЕЙЛИСТА</b>');
			setTimeout('Main.PlayPrevPlaylist()', 2000);
		} else
			setTimeout('Main.onLoad()', 2000);
	} else if (0 == this.chan_counter && 7 == Main.usb) {
		Display.status('<b style="color:blue">ПЛЕЙЛИСТ НА USB НЕ НАЙДЕН!</b>');
		setTimeout('Main.PlayPrevPlaylist()', 2000);
	} else if (0 == this.chan_counter && 7 > Main.usb && 0 == Main.pl_url.indexOf('/dtv/usb/sd')) {
		Display.hidestatus();
		Main.usb = Main.usb + 1;
		Main.playlist();
	} else {
		Display.hidestatus();
		Main.usb = 0;
		Main.Menu();
	}
};

function trim(str) {

	return str.replace(/(^\s+)|(\s+$)/g, '');
}

function get_named_val(name, str) { /* ...val_name="value"... */

	var st_off = str.indexOf(name);
	if (-1 == st_off)
		return null;
	st_off += name.length;
	if (str.charAt(st_off) != '=')
		return null;
	st_off ++;
	if (str.charAt(st_off) != "\"")
		return null;
	st_off ++;
	var en_off = str.indexOf("\"", st_off);
	if (-1 == en_off)
		return null;
	return str.substring(st_off, en_off);
}

API.Request = function(xml_url) {

	try {
		if (null != this.XHRObj) 
			this.XHRObj.destroy();
		this.XHRObj = new XMLHttpRequest();
		this.XHRObj.open('GET', xml_url, false);
		this.XHRObj.send(null);
		if (4 == this.XHRObj.readyState && 200 == this.XHRObj.status) {
			if (0 < this.XML_URL.toLowerCase().indexOf('.m3u'))
				return this.XHRObj.responseText;
			else
				return this.XHRObj.responseXML;
		}
		return false;
	} catch (e) {
		alert('API.Request Exception: ' + e);
	}
};

API.getChannel_list = function() {

	Display.loadingshow();
	this.chan_counter = 0;
	this.cat_counter = 0;
	this.channels = new Array();
	this.categories = new Array();
	if (false == Main.DEL) 
		Main.ResetSelectedPosition();
	Main.DEL = false;

    try {
	var xmlChannels = API.Request(this.XML_URL);
	if (0 < this.XML_URL.toLowerCase().indexOf('.m3u')) {
		var m3u_array = xmlChannels.split('\n');
		var title, url, playlist_url, logo_url_path, logo_30x30, description, Channel;
		logo_url_path = '';
		for (var index = 0; index < m3u_array.length; index ++) {
			if (-1 == m3u_array[index].indexOf('#EXTINF:') ||
			    -1 == m3u_array[index + 1].indexOf('://')) {
				if (-1 != m3u_array[index].indexOf('#EXTM3U')) {
					logo_url_path = get_named_val('url-tvg-logo', m3u_array[index]);
					if (null != logo_url_path) {
						if (logo_url_path.charAt((logo_url_path.length - 1)) != '/')
							logo_url_path += '/';
					} else {
						logo_url_path = '';
					}
				}
				continue;
			}
			title = trim(m3u_array[index].substr((m3u_array[index].indexOf(',') + 1)));
			url = trim(m3u_array[index + 1]);
			if (-1 != url.toLowerCase().indexOf('.m3u') ||
			    -1 != url.toLowerCase().indexOf('.xspf') ||
			    -1 != url.toLowerCase().indexOf('.xml')) {
				logo_30x30 = 'open.png';
				playlist_url = url;
				url = '';
			} else {
				logo_30x30 = get_named_val('tvg-logo', m3u_array[index]);
				if (null != logo_30x30) {
					logo_30x30 = logo_url_path + logo_30x30.toLowerCase() + '.png';
					alert('logo_30x30 = |' + logo_30x30 + '|');
				} else {
					logo_30x30 = logo_url_path + title.toLowerCase() + '.png';
				}
				playlist_url = '';
			}
			description = title + '<br>' + url;
			this.chan_counter = this.chan_counter + 1;
			Channel = Array(this.chan_counter, title, url, logo_30x30, description, '', playlist_url, '', '' , '', '', '');
			this.channels.push(Channel);
			index = index + 1;
		}
		Display.loadinghide();
		API.countPages();
		API.loadplaylistReturn();
	} else if (0 < this.XML_URL.toLowerCase().indexOf('.xspf')) {
		this.playlist_name = '';
		try {
			this.playlist_name = xmlChannels.getElementsByTagName('title')[0].childNodes[0].nodeValue;
				if (null == this.playlist_name)
					this.playlist_name = '';
		} catch (e){ }

		var items = xmlChannels.getElementsByTagName('track');
		this.loadplaylistTimer();
		for (var index = 0; index < items.length; index ++) {
			this.loadplaylistTimer();

			var title = '';
			try {
				title = items[index].getElementsByTagName('title')[0].childNodes[0].nodeValue;
				if (null == title)
					title = '';
			} catch (e){ }

			var url = '';
			try {
				url = items[index].getElementsByTagName('location')[0].childNodes[0].nodeValue;
				if (null == url)
					url = '';
			} catch (e){ }

			var logo_30x30 = '';
			try {
				logo_30x30 = items[index].getElementsByTagName('image')[0].childNodes[0].nodeValue;
				if (null == logo_30x30)
					logo_30x30 = '';
			} catch (e){ }

			var description = '';
			try {
				description = items[index].getElementsByTagName('annotation')[0].childNodes[0].nodeValue;
				if (null == description)
					description = '';
			} catch(e){ }

			var category = '';
			try {
				category = items[index].getElementsByTagName('category_id')[0].childNodes[0].nodeValue;
				if (null == category)
					category = '';
			} catch (e){ }

			var playlist_url = '';
			try {
				playlist_url = items[index].getElementsByTagName('playlist_url')[0].childNodes[0].nodeValue;
			} catch (e){ }

			var size = '';
			try {
				size = items[index].getElementsByTagName('size')[0].childNodes[0].nodeValue;
				if (null == size)
					size = '';
			} catch (e){ }
			var audiotrack_num = '';
			try {
				audiotrack_num = items[index].getElementsByTagName('audiotrack_num')[0].childNodes[0].nodeValue;
				if (null == audiotrack_num)
					audiotrack_num = '';
			} catch (e){ }

			var buffer = '';
			try {
				buffer = items[index].getElementsByTagName('buffer')[0].childNodes[0].nodeValue;
				if (null == buffer)
					buffer = '';
			} catch (e){ }

			var ibuffer = '';
			try {
				ibuffer = items[index].getElementsByTagName('ibuffer')[0].childNodes[0].nodeValue;
				if (null == ibuffer)
					ibuffer = '';
			} catch (e){ }

			var pbuffer = '';
			try {
				pbuffer = items[index].getElementsByTagName('pbuffer')[0].childNodes[0].nodeValue;
				if (null == pbuffer)
					pbuffer = '';
			} catch (e){ }

			description = title + '<br>' + url + '<br>' + description;
			clearTimeout(this.loadplaylist_timer);
			this.chan_counter = this.chan_counter + 1;//alert('chan_counter='+this.chan_counter);
			var Channel = Array(this.chan_counter, title, url, logo_30x30, description, category, playlist_url, size, audiotrack_num, buffer, ibuffer, pbuffer);
			this.channels.push(Channel);
		}

		this.all_channels = this.channels;
		API.countPages();
		this.categories.push(Array('','Все категории'));

		try {
			var category_items = xmlChannels.getElementsByTagName('category');
			for (var index = 0; index < category_items.length; index ++) {
				var cat_id = '';
				try {
					cat_id = category_items[index].getElementsByTagName('category_id')[0].childNodes[0].nodeValue;
					if (null == cat_id)
						cat_id = '';
				} catch(e){}
				var cat_name = '';
				try {
					cat_name = category_items[index].getElementsByTagName('category_title')[0].childNodes[0].nodeValue;
					if (null == cat_name)
						cat_name = '';
				} catch(e){}

				if ('' != this.cat_id)
					this.cat_counter = this.cat_counter + 1;
				var Category = new Array(cat_id, cat_name);
				this.categories.push(Category);
			}
		} catch (e){}

		Display.loadinghide();
		if (0 < this.chan_counter)
			return true;
		return false;
	} else if ('' != xmlChannels) {
		this.playlist_name = '';
		try {
			this.playlist_name = xmlChannels.getElementsByTagName('playlist_name')[0].childNodes[0].nodeValue;
				if (null == this.playlist_name)
					this.playlist_name = '';
		} catch (e){ }

		var items = xmlChannels.getElementsByTagName('channel');
		this.loadplaylistTimer();
		for (var index = 0; index < items.length; index ++) {
			this.loadplaylistTimer();

			var title = '';
			try {
				title = items[index].getElementsByTagName('title')[0].childNodes[0].nodeValue;
				if (null == title)
					title = '';
			} catch (e){ }

			var url = '';
			try {
				url = items[index].getElementsByTagName('stream_url')[0].childNodes[0].nodeValue;
				if (null == url)
					url = '';
			} catch (e){ }

			var logo_30x30 = '';
			try {
				logo_30x30 = items[index].getElementsByTagName('logo_30x30')[0].childNodes[0].nodeValue;
				if (null == logo_30x30)
					logo_30x30 = '';
			} catch (e){ }

			var description = '';
			try {
				description = items[index].getElementsByTagName('description')[0].childNodes[0].nodeValue;
				if (null == description)
					description = '';
			} catch(e){ }

			var category = '';
			try {
				category = items[index].getElementsByTagName('category_id')[0].childNodes[0].nodeValue;
				if (null == category)
					category = '';
			} catch (e){ }

			var playlist_url = '';
			try {
				playlist_url = items[index].getElementsByTagName('playlist_url')[0].childNodes[0].nodeValue;
			} catch (e){ }

			var size = '';
			try {
				size = items[index].getElementsByTagName('size')[0].childNodes[0].nodeValue;
				if (null == size)
					size = '';
			} catch (e){ }
			var audiotrack_num = '';
			try {
				audiotrack_num = items[index].getElementsByTagName('audiotrack_num')[0].childNodes[0].nodeValue;
				if (null == audiotrack_num)
					audiotrack_num = '';
			} catch (e){ }

			var buffer = '';
			try {
				buffer = items[index].getElementsByTagName('buffer')[0].childNodes[0].nodeValue;
				if (null == buffer)
					buffer = '';
			} catch (e){ }

			var ibuffer = '';
			try {
				ibuffer = items[index].getElementsByTagName('ibuffer')[0].childNodes[0].nodeValue;
				if (null == ibuffer)
					ibuffer = '';
			} catch (e){ }

			var pbuffer = '';
			try {
				pbuffer = items[index].getElementsByTagName('pbuffer')[0].childNodes[0].nodeValue;
				if (null == pbuffer)
					pbuffer = '';
			} catch (e){ }

			clearTimeout(this.loadplaylist_timer);
			this.chan_counter = this.chan_counter + 1;//alert('chan_counter='+this.chan_counter);
			var Channel = Array(this.chan_counter, title, url, logo_30x30, description, category, playlist_url, size, audiotrack_num, buffer, ibuffer, pbuffer);
			this.channels.push(Channel);
		}

		this.all_channels = this.channels; 
		API.countPages();
		this.categories.push(Array('','Все категории'));

		try {
			var category_items = xmlChannels.getElementsByTagName('category');
			for (var index = 0; index < category_items.length; index ++) {
				var cat_id = '';
				try {
					cat_id = category_items[index].getElementsByTagName('category_id')[0].childNodes[0].nodeValue;
					if (null == cat_id)
						cat_id = '';
				} catch(e){}
				var cat_name = '';
				try {
					cat_name = category_items[index].getElementsByTagName('category_title')[0].childNodes[0].nodeValue;
					if (null == cat_name)
						cat_name = '';
				} catch(e){}

				if ('' != this.cat_id)
					this.cat_counter = this.cat_counter + 1;
				var Category = new Array(cat_id, cat_name);
				this.categories.push(Category);
			}
		} catch (e){}

		Display.loadinghide();
		if (0 < this.chan_counter)
			return true;
		return false;
	} else {
		Display.loadinghide();
		if (-1 == Main.pl_url.indexOf('/dtv/usb/sd'))
			Display.status('Не поддерживаемый тип плей листа.', 0);
		if (0 != this.XML_URL.indexOf('start.xml') && -1 == Main.pl_url.indexOf('/dtv/usb/sd'))
			setTimeout('Main.PlayPrevPlaylist()', 2000);
		else
			API.loadplaylistReturn();
		return false;
	}
    } catch (e) {
	alert('API.getChannel_list Exception: ' + e);
	Display.loadinghide();
	if (-1 == Main.pl_url.indexOf('/dtv/usb/sd'))
		Display.status('Ошибка при обработке плей листа: ' + e, 0);
	if (0 != this.XML_URL.indexOf('start.xml') && -1 == Main.pl_url.indexOf('/dtv/usb/sd'))
		setTimeout('Main.PlayPrevPlaylist()', 2000);
	else
		API.loadplaylistReturn();
	return false;
    }
};

API.setCategory = function(cat_id) {

	this.channels = Array();
	if ('' == cat_id)
		API.getChannel_list();
	else {
		this.chan_counter = 0;
		Main.ResetSelectedPosition();
		for (var index = 0; index < this.all_channels.length; index ++) {
			if (this.all_channels[index][5] == cat_id)
				this.channels.push(this.all_channels[index]);
		}
		API.countPages();
	}
};

API.countPages = function() {

	this.chan_counter = this.channels.length;
	this.chan_pages = this.chan_counter;
	this.last_page_channels_counter = (this.chan_counter % 10);
	if (0 == this.last_page_channels_counter)
		this.last_page_channels_counter = 10;
	if (0 < this.last_page_channels_counter && 5 > this.last_page_channels_counter)
		this.chan_pages = (Math.round(this.chan_pages / 10) + 1);
	else
		this.chan_pages = Math.round(this.chan_pages / 10);
};
