﻿
var widgetAPI = new Common.API.Widget();
var pluginAPI = new Common.API.Plugin();
var tvKey = new Common.API.TVKeyValue();

var Main = {
	selected_channel	: 0,
	selected_page		: 0,
	chan_array_index	: 0,
	play_selected_channel	: 0,
	play_selected_page	: 0,
	play_chan_array_index	: 0,
	MainMenu_ID		: 0,
	LoadingPlayer_ID	: 1,
	LivePlayer_ID		: 2,
	VODPlayer_ID		: 3,
	Selectbox_ID		: 4,
	StreamMode		: '',
	scrolling		: 0,
	load_timer		: null,
	prev_pl_array		: [ ],
	loading_pl		: false,
	prev_ch_array		: [ ],
	MAC			: null,
	DEL			: false,
	ret			: false,
	usb			: 0,
	url			: '',
	pl_url			: '',
	usb_url			: '',
	name			: '',
	pl_name			: '',
	s_url			: false,
	url_next_page		: '',
	url_prev_page		: '',
	nuber_p			: 1,
	nuber_step		: 1,
	buffer			: '',
	ibuffer			: '',
	pbuffer			: '',
	day_current		: -1, /* Current displayed day. */
	ver			: '0.931',
};

ShowDebugOnScreen = function(text) {
	getIdb('statusbar');
	widgetAPI.putInnerHTML(getId('statusbar'), text);
};

Main.onLoad = function () {
	try {
		var NetworkPlugin = getId('pluginNetwork');
		this.MAC = NetworkPlugin.GetMAC();
		if (API.init() && Display.init() &&
		    Player.init() && Screen.init()) {
			window.onShow = Main.onShowEventTVKey;
			widgetAPI.sendReadyEvent();
		}
	} catch (e) {
		ShowDebugOnScreen('Main.PlayChannel <br>' + e);
		alert('Main.onLoad Exception: ' + e);
	}
	setInterval('Main.UpdateTimeDateMenu();', 500);
	KeyHandler.create();
	API.getChannel_list();
	setTimeout('Main.LoadMainStyle()', 2000);
};

Main.onUnload = function() {
	Player.deinit();
	alert('DEINIT');
};

Main.onShowEventTVKey = function() {
	pluginAPI.setOffScreenSaver();
	pluginAPI.setOffIdleEvent();
	pluginAPI.SetBannerState(1);
	pluginAPI.registKey(tvKey.KEY_MENU);
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	pluginAPI.unregistKey(tvKey.KEY_MUTE);
};


curWidget.onWidgetEvent = function() {// https://docs.google.com/document/d/1h7popXJefKXEFIi5MOEZu1L1Zyky_oz2KWIpzP5g92s/edit?pli=1
	Main.onShowEventTVKey();
};

Main.unregistTVKey = function() {

	pluginAPI.unregistKey(tvKey.KEY_TOOLS);
};

Main.registTVKey = function() {

	pluginAPI.registKey(tvKey.KEY_TOOLS);
};


Main.LoadMainStyle = function () {

	if (0 == API.chan_counter)
		setTimeout('Setup.setFormular();', 1000);
	getIdn('logo_bg');
	getIdb('leftHalf');
	getIdb('rightHalf');
};

Main.ResetSelectedPosition = function() {
	this.selected_channel = 0;
	this.selected_page = 0;
	this.chan_array_index = 0;
	this.play_selected_channel = 0;
	this.play_selected_page = 0;
	this.play_chan_array_index = 0;
};

Main.SaveSelectedPosition = function() {
	this.play_selected_channel = this.selected_channel;
	this.play_selected_page = this.selected_page;
	this.play_chan_array_index = this.chan_array_index;
};

Main.SetSelectedPosition = function() {
	this.selected_channel = this.play_selected_channel;
	this.selected_page = this.play_selected_page ;
	this.chan_array_index = this.play_chan_array_index;
};

Main.showCategorySelector = function() {

	if (1 < API.cat_counter) {
		getIdn('rightHalf');
		KeyHandler.setFocus(Main.Selectbox_ID);
		Selectbox.setBox('КАТЕГОРИИ', API.categories);
	}
};

Main.Menu = function() {

	try {
		clearTimeout(this.load_timer);
		getIdb('help_navi_menu');
		getIdb('channelList');
		getIdb('2_help');
		getIdb('5_help');
		getIdn('11_help');

		if (1 < API.cat_counter)
			getIdb('3_help');
		else
			getIdn('3_help');
		if (Player.state != Player.STATE_STOPPED) {
			getIdn('0_help');
			getIdb('1_help');
			getIdb('6_help');
			getIdn('7_help');
			if (Player.mode == Player.MODE_VOD)
				getIdb('8_help');
			else
				getIdn('8_help');
		} else {
			getIdb('0_help');
			getIdn('1_help');
			getIdb('4_help');
			getIdn('8_help');
			if (0 < this.prev_pl_array.length) {
				getIdb('6_help');
				getIdn('7_help');
				if (0 == API.XML_URL.indexOf('start.xml')) {
					Display.status(API.XML_URL);
				}
			} else if (0 != API.XML_URL.indexOf('start.xml')) {
				getIdn('6_help');
				getIdb('7_help');
			} else {
				getIdn('6_help');
				getIdn('7_help');
			}
		}
		widgetAPI.putInnerHTML(getId('widget_title'), API.XML_URL);
		this.loading_pl = false;
		Main.updatePage();
		KeyHandler.setFocus(this.MainMenu_ID);
	} catch (e) {
		alert('Main.Menu Exception: ' + e);
	}
};


Main.LogoStyle = function(i, s, x) {
	var f = 0;
	var l, w;

	if (1 == x && 1 == f) {
		l = '67px';
		w = '54px';
	} else if (1 == x) {
		l = '75px';
		w = '38px';
	} else if (1 == f) {
		l = '74px';
		w = '66px';
	} else {
		l = '82px';
		w = '44px';
	}

	getId(i).src = s;
	getId(i).style.left = l;
	getId(i).style.width = w;
};

Main.updatePage = function() {

	try {
		this.url_next_page = '';
		this.url_prev_page = '';
		this.ret = false;
		var chan = Array();
		var chan_on_page = 10;

		if (this.selected_page > (API.chan_pages - 1))
			this.selected_page = 0;
		if (0 > this.selected_page)
		    this.selected_page = (API.chan_pages - 1);

		for (var index = 0; index < 10; index ++) {
			getIdb(('ch' + index));
			widgetAPI.putInnerHTML(getId('title' + index), '');
			getIdb(('title' + index));
			getIdb(('number' + index));
		}
		if (this.selected_page == (API.chan_pages - 1)) {
			chan_on_page = API.last_page_channels_counter;
			for (var index = chan_on_page; index < 10; index ++)
				getIdn(('ch' + index));
			if (this.selected_channel > (API.last_page_channels_counter - 1))
				this.selected_channel = (API.last_page_channels_counter - 1);
		}
		for (var index = 0; index < chan_on_page; index ++) {
			var chan_array_index = ((10 * this.selected_page) + index);
			chan[index] = getId(('chan' + index));
			widgetAPI.putInnerHTML(getId('number' + index), (chan_array_index + 1));
			var logo = API.channels[chan_array_index][3];
			var logopapka = 'logos/';
			var png = '.png';
			if (0 <= logo.indexOf(':'))
				logopapka = '';
			var pl = API.channels[chan_array_index][6];
			var lct = API.channels[chan_array_index][4];
			if ('' != logo)//инфо в лого
				Main.LogoStyle(('img' + index), (logopapka + logo), 1);
			else if ('' != pl) // иконка для названия плейлиста, если нет logo
				Main.LogoStyle(('img' + index), 'logos/open.png', 1);
			else {
				var lt = API.channels[chan_array_index][1];
				if ('' != lct) { //в дескрип.есть инфо
					var lc = parseInt(API.channels[chan_array_index][4]);
					var la = (lct - lc);
					if (0 == la) { //в дескрип.есть индекс
						//...
					} else  //в дескрип.есть инфо.
						Main.LogoStyle(('img' + index), (logopapka + lt + png), 1);
				} else //в дескрип.нет инфо.
					Main.LogoStyle(('img' + index), (logopapka + lt + png), 1);
			}
			//var title = API.channels[chan_array_index][1];
			widgetAPI.putInnerHTML(getId(('title' + index)), API.channels[chan_array_index][1]);
			if (-1 < API.channels[chan_array_index][1].indexOf('следующая страница'))
				this.url_next_page = API.channels[chan_array_index][6];
			if (-1 < API.channels[chan_array_index][1].indexOf('предыдущая страница'))
				this.url_prev_page = API.channels[chan_array_index][6];
		}

	} catch (e) {
		alert('Main.updatePage Exception: ' + e);
	}

	if ('' != this.url_next_page || '' != this.url_prev_page) {
		this.ret = true;
		widgetAPI.putInnerHTML(getId('widget_title'), (this.nuber_p +'-я страница'));
	}
	getIdb('main');// Показываем страницу
	Main.updateChannel();
};

Main.UpdatePlayerStatusbar = function() {
	var index = this.chan_array_index;
	widgetAPI.putInnerHTML(getId('ch_number'), (index + 1));
	widgetAPI.putInnerHTML(getId('ch_name'), API.channels[index][1]);
	var logo = API.channels[index][3];
	var logopapka = 'logos/';
	var lct = API.channels[index][4];

	if (0 <= logo.indexOf(':'))
		logopapka = '';

	if ('' != logo ) //инфо в лого
		Main.LogoStyle('ch_img', (logopapka + logo), 0);
	else {
		var lt = API.channels[index][1];
		if ('' != lct) { //в дескрип.есть инфо.
			var lc = parseInt(API.channels[index][4]);
			var la = (lct - lc);
			if ('' == la) { //в дескрип.есть индекс
				//...
			} else  //в дескрип.есть инфо.
				Main.LogoStyle('ch_img', (logopapka + lt + '.png'), 0);
		} else //в дескрип.нет инфо.
			Main.LogoStyle('ch_img', (logopapka + lt + '.png'), 0);
	}
};

Main.pl_tsnakeman_page_counter = function() {

	if (true == this.ret && false == KeyHandler.k) {
		if (API.channels[this.chan_array_index][1].indexOf('следующая страница')>-1) {
			this.nuber_p ++;
			this.nuber_step ++;
		}
		if (API.channels[this.chan_array_index][1].indexOf('предыдущая страница')>-1) {
			this.nuber_p = (this.nuber_p - 1);
			this.nuber_step ++;
		}
	}
};

Main.LoadTimer = function(func, time) {
	
	clearTimeout(this.load_timer);
	this.load_timer = setTimeout(func, time);
};


Main.updateChannel = function() {

	clearTimeout(this.load_timer);

	for (var index = 0; index < 10; index ++) {
		getId(('chan' + index)).style.backgroundImage = '';
		getId(('number' + index)).style.backgroundImage = '';
	}
	this.chan_array_index = 10 * this.selected_page + this.selected_channel;
	if ('' != API.channels[this.chan_array_index][2]) {
		KeyHandler.k = false;
		this.ret = false;
	}
	getId(('number' + this.selected_channel)).style.backgroundImage = 'url(img/menu1_act.png)';
	getId(('chan' + this.selected_channel)).style.backgroundImage = 'url(img/menu_act.png)';
	getIdn('infoList');
	var yt = API.channels[this.chan_array_index][4];
	if ('' != yt) //в дескрип.есть инфо
		Main.scrolling = 0;
	Main.LoadTimer('Main.showinfoList()', 200);
	this.name = API.channels[this.chan_array_index][1];
};

Main.showinfoList = function() {
	var dinfo = API.channels[this.chan_array_index][4];
	var y = parseInt(API.channels[this.chan_array_index][4]);
	var info = '<table><tr><h3>';

	if ('' != API.playlist_name)
		info += "<font color='#00ccff'>" + API.playlist_name + '</font><td></td><td></td><td></td><td></td>';
	info += '</h3></tr></table>';
	if ('' == dinfo || 0 == y)
		dinfo = 'Дополнительной информации нет !';
	info ='<table>' + info + dinfo + '</table>';
	widgetAPI.putInnerHTML(getId('infoList'), info);
	getIdb('infoList');
};


Main.PlayPrevChannel = function() {
	var index = (this.prev_ch_array.length - 1);

	if (0 < index) {
		var prev_chan = this.prev_ch_array[(index - 1)];
		this.selected_channel = prev_chan[0];
		this.selected_page = prev_chan[1];
		this.chan_array_index = prev_chan[2];
		Main.PlayChannel();
		Display.status('предыдущий канал');
	} else
		Display.status('стартовый канал');
};

Main.SavePrevChannel = function() {
	var chan_info = new Array(this.selected_channel, this.selected_page, this.chan_array_index);

	this.prev_ch_array.push(chan_info);
};

Main.PlayPrevPlaylist = function() {
	var index = (this.prev_pl_array.length - 1);
	var prev_playlist;

	if (-1 < index) {
		if (KeyHandler.bl) {
			prev_playlist = this.prev_pl_array[(index - this.nuber_step)];
			KeyHandler.bl = false;
			this.nuber_step = 1;
			this.nuber_p = 1;
		} else
			prev_playlist = this.prev_pl_array[index];
		API.XML_URL = prev_playlist[0];
		this.selected_channel = prev_playlist[1];
		this.selected_page = prev_playlist[2];
		this.chan_array_index = prev_playlist[3];
		this.nuber_p = prev_playlist[4];
		this.nuber_step = prev_playlist[5];
		this.prev_pl_array.pop();
		setTimeout('API.getChannel_list();', 50);
		Display.status('Предыдущий плейлист', 0);
	} else if (0 != API.XML_URL.indexOf('start.xml')) {
		this.star = true;
		Main.playlist();
	} else {
		Main.DEL = false;
		Display.status('Стартовый плейлист!');
	}
};

Main.SavePrevPlaylist = function() {
	var list_info = new Array(API.XML_URL, this.selected_channel, this.selected_page, this.chan_array_index, this.nuber_p, this.nuber_step);

	this.prev_pl_array.push(list_info);
};

Main.selectNextChannel = function() {

	this.selected_channel ++;
	if (10 <= this.selected_channel ||
	    (this.selected_page == (API.chan_pages - 1) && this.selected_channel == API.last_page_channels_counter)) {
		this.selected_channel = 0;
		this.selected_page ++;
		Main.updatePage();
	} else
		Main.updateChannel();
};

Main.selectPrevChannel = function() {

	this.selected_channel --;
	if (0 == this.selected_page && 0 > this.selected_channel) {
		this.selected_channel = (API.last_page_channels_counter - 1);
		this.selected_page = (API.chan_pages - 1);
		Main.updatePage();
	}
	else if (0 > this.selected_channel) {
		this.selected_channel = 9;
		this.selected_page --;
		Main.updatePage();
	} else
		Main.updateChannel();
};

Main.selectNextPage = function() {
	this.selected_page ++;
	Main.updatePage();
};

Main.selectPrevPage = function() {
	this.selected_page --;
	Main.updatePage();
};

Main.PlayChannel = function() {

    try {
	this.url = API.channels[this.chan_array_index][2];
	this.pl_url = API.channels[this.chan_array_index][6];
	this.name = API.channels[this.chan_array_index][1];
	this.pl_name = API.playlist_name;
	this.buffer = API.channels[this.chan_array_index][9];
	this.ibuffer = API.channels[this.chan_array_index][10];
	this.pbuffer = API.channels[this.chan_array_index][11];
	

	if (0 == this.url.indexOf('stop') || 0 == this.pl_url.indexOf('stop'))
		Main.Menu();
	else if ('' != this.pl_url) {
		Main.playlist();
	} else if ('' != this.url) {
		if (Player.state != Player.STATE_STOPPED) {
			Player.stopVideo();
		}
		Main.SavePrevChannel();
		Main.SaveSelectedPosition();
		Display.status1(API.channels[Main.chan_array_index][0]);
		if (0 == this.url.indexOf('http://')) {
			if (-1 != this.url.indexOf('.m3u8'))
				Main.StreamMode = 'hls';
			else if (-1 != this.url.indexOf('.mp3'))
				Main.StreamMode = 'http.mp3';
			else if (-1 != this.url.indexOf('.flv'))
				Main.StreamMode = 'rtmp.flv';
			else
				Main.StreamMode = 'http';
		} else if (0 == this.url.indexOf('udp://'))
			Main.StreamMode = 'udp';
		else if (0 == this.url.indexOf('mms://'))
			Main.StreamMode = 'mms';
		else if (0 == this.url.indexOf('rtsp://'))
			Main.StreamMode = 'rtsp';
		else if (0 == this.url.indexOf('rtmp://')) {
			if (-1 != this.url.indexOf('.flv'))
				Main.StreamMode = 'rtmp.flv';
			else
				Main.StreamMode = 'rtmp';
		} else 
			Main.StreamMode = 'file';
		Main.PlayNoFlashStream();
	} else {
		Display.status('Нет адреса!');
		setTimeout('Main.Menu();', 2000);
	}
    } catch (e) {
	ShowDebugOnScreen('Main.PlayChannel <br>' + e);
	alert('Main.PlayChannel Exception: ' + e);
    }
};

Main.PlayNoFlashStream = function() {

	Display.hidemenu();
	getIdb('screen_size');
	widgetAPI.putInnerHTML(getId('resolution'), '');
	widgetAPI.putInnerHTML(getId('bitrate'), '');
	Main.UpdatePlayerStatusbar();
	if ('hls' == Main.StreamMode)
		this.url = this.url + '|COMPONENT=HLS';
	alert('URL = ' + this.url);
	Player.playVideo(this.url);
};

Main.playlist = function() {

	if (true == this.star) {
		this.pl_url = 'start.xml';
		this.star = false;
		this.prev_pl_array = new Array();
	} else if (0 == this.usb && 0 == this.pl_url.indexOf('/dtv/usb/sd'))
		this.usb = 7;
	else if (0 <= this.pl_url.indexOf('usb/')) {
		var USBRootPaths = new Array('/dtv/usb/sda1', '/dtv/usb/sdb1', '/dtv/usb/sdc1', '/dtv/usb/sdd1', '/dtv/usb/sda', '/dtv/usb/sdb', '/dtv/usb/sdc', '/dtv/usb/sdd');
		var USBRootPath = USBRootPaths[this.usb];
		if (0 == this.pl_url.indexOf('usb/') && 0 == this.usb)
			this.usb_url = this.pl_url.substr(3);
		this.pl_url = USBRootPath + this.usb_url;
	}

	if (0 == this.usb && false == this.DEL) {
		this.prev_ch_array = new Array();
		Main.SavePrevPlaylist();
		Main.pl_tsnakeman_page_counter();
		KeyHandler.k = false;
	}

	API.XML_URL = this.pl_url;
	alert('url = ' + this.pl_url);
	if (0 != this.pl_url.indexOf('usb/'))
		Display.status('Загрузка плейлиста !', 0);
	setTimeout('API.getChannel_list();', 50);
};


function trim(str) {
	return str.replace(/(^\s+)|(\s+$)/g, '');
}

function mTg(str, tag) {
	var res = '';

	if (null != str && '' != str)
		res = '<' + tag + '>' + '<![CDATA[' + trim(str.replace(/[\n\r\t]/g, '')) + ']]>' + '</' + tag + '>';
	return res;
}

function xml(x, y) {
	return mTg(API.channels[Main.chan_array_index][x], y);
}


function fmt_time(h, m, s) {
	return ((h > 9 ? h : ('0' + h)) + ':' + (m > 9 ? m : ('0' + m)) + ':' + (s > 9 ? s : ('0' + s)));
}

Main.UpdateTimeDateMenu = function() {
	var now = new Date();
	var uday = now.getDay();
	var str_time = fmt_time(now.getHours(), now.getMinutes(), now.getSeconds());

	getId('widget_time').innerHTML = str_time;
	getId('time').innerHTML = str_time;

	if (Main.day_current != uday) {
		var uyear = now.getFullYear();
		var umonth = now.getMonth();
		var udate = now.getDate();
		var days = new Array ('Вскресенье', 'Понедельник', 'Вторник', 'Среда', 'Четверг', 'Пятница', 'Суббота');
		var months = new Array ('Января', 'Февраля', 'Марта', 'Апреля', 'Мая', 'Июня', 'Июля', 'Августа', 'Сентября', 'Октября', 'Ноября', 'Декабря');
		var dateValue = days[uday] + ', ' + udate + ' ' + months[umonth] + ' ' + uyear;
		getId('widget_date').innerHTML = dateValue;
		Main.day_current = uday;
	}
};

function getIdb(x) {
	return getId(x).style.display = 'block';
}

function getIdn(x) {
	return getId(x).style.display = 'none';
}

function getId(x,y) {
	return document.getElementById(x);
}

function getCl(x) {
	return document.getElementsByClassName(x);
}

var Display = {
	status_timer	: null,
	statusDiv	: null,
	status1_timer	: null,
	status1Div	: null,
	loadingshow_timer : null,
	index		: 1,
	run		: 0,
	totalTime	: 0,
	time		: 0,
};

Display.init = function() {

	this.status1Div = getId('status1');
	this.statusDiv = getId('status');
	if (!this.statusDiv && !this.status1Div)
		return false;
	return true;
};

Display.loadingshow = function() {

	if (0 == this.run) {
		getIdb('loading');
		this.loadingshow_timer = setTimeout('Player.ReturnMenu();', 120000);
		this.run = 1;
		Display.loadingstep();
		KeyHandler.setFocus(Main.LoadingPlayer_ID);
	}
};

Display.loadinghide = function() {

	getIdn('loading');
	clearTimeout(this.loadingshow_timer);
	this.run = 0;
};

Display.loadingstep = function() {

	if (10 > this.index)
		getId('imgAnim').src = 'img/loading/loading_0' + this.index + '.png';
	else
		getId('imgAnim').src = 'img/loading/loading_' + this.index + '.png';
	this.index ++;
	if (12 < this.index)
		this.index = 1;
	if (this.run)
		setTimeout('Display.loadingstep();', 200);
};

Display.hidemenu = function() {
	getIdn('main');
};

Display.showmenu = function() {
	getIdb('main');
};

Display.hideplayer = function() {
	getIdn('player');
};

Display.showplayer = function() {

	if (Player.state == Player.STATE_PLAYING &&
	    Player.mode == Player.MODE_VOD) {
		getIdn('help_navi_l_player');
		getIdb('help_navi_vod_player');
		getIdb('infoMovi');
		if (true == Player.repeat)
			Display.status('Повторное воспроизведение!');
		if (true == Player.next && false == Player.repeat)
			Display.status('Последовательное воспроизведение!');
	} else if (Player.state == Player.STATE_PAUSE) {
		getIdn('vod_pause');
		getId('vod_play').style.display = '';
		getId('statusbar').style.display = '';
	} else if (Player.mode == Player.MODE_STREAMING) {
		getIdb('help_navi_l_player');
		getIdn('help_navi_vod_player');
		getIdn('infoMovi');
	}
	clearTimeout(this.infobar_timer);
	getIdb('player');
	if (Player.state != Player.STATE_PAUSE && 'http.mp3' != Main.StreamMode)
		Display.infobarTimer();
};

Display.infobarTimer = function() {
	this.infobar_timer = setTimeout('Display.hideplayer()', 5000);
};

Display.status = function(status, d) {

	getIdn('widget_title');
	getIdb('statusbar');
	widgetAPI.putInnerHTML(this.statusDiv, status);
	clearTimeout(this.status_timer);
	if ('' != d)
		this.status_timer = setTimeout('Display.hidestatus()', 2000);
};

Display.status1 = function(status1) {
	getIdb('statusbar1');
	widgetAPI.putInnerHTML(this.status1Div, status1);
	clearTimeout(this.status1_timer);
	this.status1_timer = setTimeout('Display.hidestatus1()', 2000);
};

Display.hidestatus = function() {
	getIdn('statusbar');
	getId('widget_title').style.display = '';
};

Display.hidestatus1 = function() {
	getIdn('statusbar1');
};

msecToStr = function(sec) {

	sec = Math.floor(sec / 1000);
	m = Math.floor(sec / 60);
	sec = (sec % 60);
	h = Math.floor(m / 60);
	m = (m % 60);

	return (fmt_time(h, m, sec));
};

Display.setTime = function(time, totalTime) {
	var Barwidth, timeHTML;

	if (0 != totalTime) {
		var tP = parseInt((100 * time) / totalTime, 10);
		Barwidth = (Math.floor(tP * 6) + 'px');
		timeHTML = (tP > 9 ? tP : ('0' + tP)) + '%/' + msecToStr(time);
		timeHTML += '/' + msecToStr(totalTime);
	} else {
		Barwidth = '0';
		timeHTML = '00%/00:00:00/00:00:00';
	}
	getId('progressBar').style.width = Barwidth;
	getId('timeInfo').innerHTML = timeHTML;
};

