﻿// http://samsungdforum.com/Guide/ref00014/index.html
// http://samsungdforum.com/Guide/ref00008/index.html

var Player = {
	SefPlugin	: null,
	mwPlugin	: null,
	originalSource	: null,
	size		: 0,
	w		: 0,
	h		: 0,
	total_time	: 0,
	cur_time	: 0,
	next		: false,
	repeat		: false,
	get_res_try	: 0,
	get_bitrates_try: 0,
	net_try		: 0,
	net_retry_max	: 5,
	play_speed	: 0,
	tnum		: 0,
	url		: '',
	state		: -1,
	STATE_STOPPED	: 0,
	STATE_LOADING	: 1,
	STATE_PLAYING	: 2,
	STATE_PAUSE	: 3,
	STATE_STOPPING	: 4,
	mode		: 0,
	MODE_STREAMING	: 0,
	MODE_VOD	: 1,
};

Player.init = function() {

	this.state = this.STATE_STOPPED;
	this.SefPlugin = document.getElementById('pluginObjectSef');
	this.mwPlugin = document.getElementById('pluginObjectTVMW');
	if (null == this.SefPlugin ||
	    null == this.mwPlugin || null == this.mwPlugin.GetSource)
		return (false);
	this.SefPlugin.Open('Player', '1.010', 'Player');
	this.SefPlugin.OnEvent = 'Player.Sef_onEvents';
	this.originalSource = this.mwPlugin.GetSource();
	this.mwPlugin.SetMediaSource();

	return (true);
};

Player.deinit = function() {

	alert('Player deinit !!!');
	this.stop();
	this.SefPlugin.Close();
	if (this.mwPlugin != null) {
		this.mwPlugin.SetMediaSource(this.originalSource);
		this.mwPlugin = null;
	}
};

Player.stop = function() {

	if (this.state == this.STATE_STOPPED)
		return;
	this.state = this.STATE_STOPPED;
	this.w = 0;
	this.h = 0;
	this.total_time = 0;
	this.cur_time = 0;
	this.play_speed = 0;
	this.SefPlugin.Execute('Stop');
	Display.setTime(0, 0);
};

Player.playVideo = function(url) {

	if (url == null) {
		alert('url = null, Can not play');
		return;
	}
	this.stop();
	Display.loadingshow();
	this.url = url;
	this.net_try = 0;
	this.SEFPlay(url);
};

Player.stopVideo = function() {

	this.stop();
	this.SefPlugin.Execute('ClearScreen');
	Display.hideplayer();
	Display.loadinghide();
	Screen.modeD2 = 0;
	Main.registTVKey();
	document.getElementById('statusbar').style.display = 'none';
};

Player.ReturnMenu = function() {

	this.stopVideo();
	Main.Menu();
	this.repeat = false;
	this.next = false;
};

Player.GetResolution = function() {

	if (this.state == this.STATE_STOPPED)
		return;
	this.setSize(1, 0);
	var res = this.SefPlugin.Execute('GetVideoResolution');
	res = res.split('|');
	this.w = res[0];
	this.h = res[1];

	if (this.w == 0 && this.get_res_try < 5) {
		setTimeout('Player.GetResolution()', 100);
		this.get_res_try ++;
	} else {
		switch (this.w) {
		case 5:
			this.h = 432;
			this.w = 540;
			break;
		case 4:
			this.h = 270;
			this.w = 480;
			break;
		case 3:
			this.h = 288;
			this.w = 384;
			break;
		default:
			if (this.w < 128) {
				this.h = 0;
				this.w = 0;
			}
			break;
		}
		var res = '<center>' + this.w + 'x' + this.h + '</center>';
		widgetAPI.putInnerHTML(document.getElementById('resolution'), res);
	}
};

Player.GetBitrates = function() {
	var bitrate;

	if (this.state == this.STATE_STOPPED)
		return;
	// !!!alert('GetAvailableBitrates: ' + this.SefPlugin.Execute('GetAvailableBitrates'));
	bitrate = this.SefPlugin.Execute('GetCurrentBitrates');
	if (0 == bitrate && this.get_bitrates_try < 5) {
		setTimeout('Player.GetBitrates()', 100);
		this.get_bitrates_try ++;
	}
	if (0 != bitrate) {
		bitrate = parseInt((bitrate / 1024)) + ' kbps';
		widgetAPI.putInnerHTML(document.getElementById('bitrate'), bitrate);
	}
};

Player.GetVideoSize = function() {

	if (this.state == this.STATE_STOPPED)
		return;
	if (Screen.getModeD2() == 0) {
		if (API.channels[Main.play_chan_array_index][7] != '')
			this.size = parseInt(API.channels[Main.chan_array_index][7]);
		else
			this.size = parseInt(API.Size);
	} else
		this.size = 0;
	setTimeout("Player.setSize(Player.size, 0)", 900);
};


Player.PlaySpeedChange = function(val) {

	if (this.state != this.STATE_PLAYING)
		return;
	if (0 == val)
		this.play_speed = 0; /* Set to: 1x speed. */
	else
		this.play_speed += val;
	/* Convert to Player values. */
	if (0 <= this.play_speed)
		val = (1 << this.play_speed);
	else
		val = -(1 << (-this.play_speed));
	this.SefPlugin.Execute('SetPlaybackSpeed', val);
	Display.status('Speed: ' + val + 'x');
};


Player.setSize = function(mode, show) {

	if (this.state == this.STATE_STOPPED)
		return;
	this.size = mode;
	var w = this.w;
	var h = this.h;
	var dx = 0, dy, dw, dh, cx, cy, cw, ch, s = '';
	if (this.w > 0)
		dx = 0; dy = 0; dw = 960; dh = 540;
	cx = 0; cy = 0; cw = 0; ch = 0;
	if (this.w == 0 || this.size == 4) {
		this.SefPlugin.Execute('SetCropArea', cx, cy, cw, ch);
	}
	switch (mode) {
	case 0:
		if (w == 0) {
			s = 'w/h=2';
			dx = 0; dy = 30; dw = 960; dh = 480;
		} else
			s = '16x9 FULL';
		cx = 0; cy = 0; cw = w; ch = h;
		break;
	case 1:
		if (w == 0) {
			s = 'w/h=1.78';
			dx = 0; dy = 0; dw = 960; dh = 540;
		} else {
			s = '14x9 ZOOM';
			cx = 0; cy = (0.0625 * h); cw = w; ch = (0.875 * h);
		}
		break;
	case 2:
		if (w == 0) {
			s = 'w/h=1.67';
			dx = 30; dy = 0; dw = 900; dh = 540;
		} else {
			if ((w / h) > 1.34) {
				s = 'ORIGINAL';
				dh = (960 * h / w); dy = ((540 - dh) / 2);
			cx = 0; cy = 0; cw = w; ch = h;
			} else {
				s = '4x3 KINOZOOM';
				cx = 0; cy = (0.115 * h); cw = w; ch = (0.77 * h);
			}
		}
		break;
	case 3:
		if (w == 0) {
			s = 'w/h=1.56';
			dx = 60; dy = 0; dw = 840; dh = 540;
		} else {
			s = '16x9 ZOOM';
			cx = (0.0625 * w); cy = (0.0625 * h); cw = (0.875 * w); ch = (0.875 * h);
		}
		break;
	case 4:
		if (w <= 732 && (w / h) < 1.35 || this.w == 0) {
			s = '4x3';
			dx = 120; dw = 720;
		}
		break;
	}
	if (show > 0)
		Display.status(s);
	this.SefPlugin.Execute('SetDisplayArea', dx, dy, dw, dh);
	this.SefPlugin.Execute('SetCropArea', cx, cy, cw, ch);
};

Player.getSize = function() {

	return this.size;
};

Player.MinutesJump = function(m) {

	if (this.state == this.STATE_LOADING)
		return;
	var sign = '';
	if (m > 0) {
		sign = '+';
		if (m < ((this.total_time - this.cur_time) / 60000))
			this.SefPlugin.Execute('JumpForward', (m * 60));
	} else if (m < 0) {
		if (m > ((this.cur_time / 60000) * -1))
			this.SefPlugin.Execute('JumpBackward', ((m * 60) * -1));
	}
	Display.status((sign + m + ' мин.'));
	Display.showplayer();
};

Player.PercentJump = function(p) {

	if (this.state == this.STATE_LOADING)
		return;
	var jump_to_min = (((this.total_time * (p / 10)) - this.cur_time) / 1000);
	if (jump_to_min > 0)
		this.SefPlugin.Execute('JumpForward', jump_to_min); 
	else if (jump_to_min < 0)
		this.SefPlugin.Execute('JumpBackward', (jump_to_min * -1));
	Display.status(((p * 10) + '%'), 0); 
	Display.showplayer();
};

Player.resumeVideo = function() {

	if (this.state != this.STATE_PAUSE ||
	    this.mode != this.MODE_VOD)
		return;
	this.SefPlugin.Execute('Resume');
	this.state = this.STATE_PLAYING;
	Display.status(' > > > ');
	if (Main.StreamMode != 'http.mp3')
		Display.hideplayer();
};

Player.pauseVideo = function() {

	if (this.state != this.STATE_PLAYING ||
	    this.mode != this.MODE_VOD)
		return;
	this.SefPlugin.Execute('Pause');
	this.state = this.STATE_PAUSE;
	Display.showplayer();
	widgetAPI.putInnerHTML(Display.statusDiv, 'Пауза');
};

Player.SetBuffer = function () {
	var buffer, ibuffer, pbuffer;

	alert('Player.SetBuffer: buffer = ' + Main.buffer + ' mb, ibuffer = ' + Main.ibuffer + ' mb, pbuffer = ' + Main.pbuffer + ' mb');
	/* buffer */
	if (Main.buffer == '')
		return;
	buffer = (parseInt(Main.buffer) * 1024 * 1024);
	/* ibuffer */
	if (Main.ibuffer == '') {
		ibuffer = buffer;
	} else {
		ibuffer = (parseInt(Main.ibuffer) * 1024 * 1024);
	}
	if (buffer <= ibuffer)
		ibuffer = (buffer / 2);
	/* pbuffer */
	if (Main.pbuffer == '') {
		pbuffer = ibuffer;
	} else {
		pbuffer = (parseInt(Main.pbuffer) * 1024 * 1024);
	}
	if (ibuffer <= pbuffer)
		pbuffer = (ibuffer / 2);
	this.SefPlugin.Execute('SetTotalBufferSize', buffer);
	this.SefPlugin.Execute('SetInitialBuffer', ibuffer);
	this.SefPlugin.Execute('SetPendingBuffer', pbuffer);
	this.SefPlugin.Execute('SetInitialTimeOut', 10);
};

Player.SEFPlay = function (url) {

	if (this.state != this.STATE_STOPPED)
		return;
	this.state = this.STATE_LOADING;
	this.SefPlugin.Execute('InitPlayer', url);
	if (Screen.getModeD2() != 0) {
		if (Main.buffer != '')
			Main.buffer = 20;
		this.SefPlugin.Execute('SetPlayerProperty', '2', '3', Screen.getModeD2());
	} else if (Main.StreamMode == 'http.mp3') {
		if (Main.buffer != '')
			Main.buffer = 1;
		this.SefPlugin.Execute('SetPlayerProperty', '5', '0', '0');
	}
	this.SetBuffer();
	this.SefPlugin.Execute('StartPlayback');
};

Player.Sef_onEvents = function(event, data1, data2) {
	var EvTypes = {
		CONNECTION_FAILED: 1,
		AUTHENTICATION_FAILED: 2,
		STREAM_NOT_FOUND: 3,
		NETWORK_DISCONNECTED: 4,
		NETWORK_SLOW: 5,
		RENDER_ERROR: 6,
		RENDERING_START: 7,
		RENDERING_COMPLETE: 8,
		STREAM_INFO_READY: 9,
		DECODING_COMPLETE: 10,
		BUFFERING_START: 11,
		BUFFERING_COMPLETE: 12,
		BUFFERING_PROGRESS: 13,
		CURRENT_DISPLAY_TIME: 14,
		AD_START: 15,
		AD_END: 16,
		RESOLUTION_CHANGED: 17,
		BITRATE_CHANGED: 18,
		SUBTITLE: 19,
		CUSTOM: 20
	};

	switch (event) {
	case EvTypes.CONNECTION_FAILED:
		this.net_try ++;
		if (this.net_try < this.net_retry_max) {
			Display.status('Connecting...' + this.net_try);
			this.stop();
			this.SEFPlay(this.url);
		} else {
			this.error(7);
		}
		break;
	case EvTypes.AUTHENTICATION_FAILED:
		this.error(8);
		break;
	case EvTypes.STREAM_NOT_FOUND:
		this.error(9);
		break;
	case EvTypes.NETWORK_DISCONNECTED:
		this.net_try ++;
		if (this.net_try < this.net_retry_max) {
			Display.status('Reconnecting...' + this.net_try);
			this.stop();
			this.SEFPlay(this.url);
		} else {
			this.error(10);
		}
		break;
	case EvTypes.NETWORK_SLOW:
		Display.status('NETWORK_SLOW');
		break;
	case EvTypes.RENDER_ERROR:
		this.error(parseInt(data1));
		break;
	case EvTypes.RENDERING_START:
		break;
	case EvTypes.RENDERING_COMPLETE:
		if (this.state != this.STATE_LOADING &&
		    this.state != this.STATE_PLAYING)
			break;
		if (this.repeat == true && this.next == true) {
			Display.hideplayer();
			this.playVideo(this.url);
		} else if (this.next == true) {
			this.stopVideo();
			Main.selectNextChannel();
			Main.PlayChannel();
		} else { /* End of video. */
			this.ReturnMenu();
		}
		break;
	case EvTypes.STREAM_INFO_READY:
		this.net_try = 0;
		Display.loadinghide();
		if (this.state != this.STATE_LOADING &&
		    this.state != this.STATE_PLAYING)
			break;
		this.tnum = this.SefPlugin.Execute('GetTotalNumOfStreamID', 1);
		if (this.tnum > 1) {
			var num = API.channels[Main.play_chan_array_index][8];
			if (num != '')
				this.SEFSetAudioStream((num - 1), 2000);
			//setTimeout("Display.status('Обнаружены другие звуковые дорожки!')", 2000);
		}
		this.total_time = this.SefPlugin.Execute('GetDuration');
		Display.setTime(0, this.total_time);
		this.GetBitrates();
		this.GetResolution();
		break;
	case EvTypes.DECODING_COMPLETE:
		Display.status('DECODING_COMPLETE');
		break;
	case EvTypes.BUFFERING_START:
		if (this.state != this.STATE_LOADING &&
		    this.state != this.STATE_PLAYING)
			break;
		Display.status('Буфер: 0%');
		break;
	case EvTypes.BUFFERING_PROGRESS:
		if (this.state != this.STATE_LOADING &&
		    this.state != this.STATE_PLAYING)
			break;
		Display.status('Буфер: ' + data1 + '%');
		break;
	case EvTypes.BUFFERING_COMPLETE:
		if (this.state != this.STATE_LOADING &&
		    this.state != this.STATE_PLAYING)
			break;
		Display.status('Буфер: 100%');
		if (this.total_time > 0 && Main.StreamMode != 'mms' &&
		    Main.StreamMode != 'hls' || Main.StreamMode == 'http.mp3') {
			KeyHandler.setFocus(Main.VODPlayer_ID);
			this.mode = this.MODE_VOD; 
		} else {
			KeyHandler.setFocus(Main.LivePlayer_ID);
			this.mode = this.MODE_STREAMING; 
		}
		if (this.state != this.STATE_PLAYING) {
			this.state = this.STATE_PLAYING; 
			Display.showplayer();
			Main.unregistTVKey();
			this.GetVideoSize();
		} else if (Main.StreamMode != 'http.mp3')
			setTimeout('Display.hideplayer()', 2000);
		break;
	case EvTypes.CURRENT_DISPLAY_TIME:
		if (this.state != this.STATE_PLAYING ||
		    this.mode != this.MODE_VOD)
			break;
		this.cur_time = parseInt(data1, 10);
		Display.setTime(this.cur_time, this.total_time);
		break;
	default:
		alert('OnEvent event = [' + event + ']');
		alert('OnEvent data1 = [' + data1 + ']');
		alert('OnEvent data2 = [' + data2 + ']');
		Display.status('Unknown SEF event');
	}
};

Player.error = function(err) {
	var err_descr = [
		'',
		'RenderError: неподдерживаемый контейнер',
		'RenderError: неподдерживаемый видео кодек',
		'RenderError: неподдерживаемый аудио кодек',
		'RenderError: неподдерживаемое разрешение видео',
		'RenderError: неправильная частота кадров',
		'RenderError: поток повреждён',
		'Connection failed',
		'Authentication failed',
		'Stream not found',
		'Network disconnected'
	];

	Display.loadinghide();
	if (0 == err)
		return;
	if (11 > err)
		Display.status(err_descr[err].toString());
	else
		Display.status('Unknown error: ' + err);
	if (3 != err) { /* Unsupported audio - non fatal error. */
		this.state = this.STATE_STOPPING;
		setTimeout('Player.ReturnMenu()', 1500);
	}
};


Player.SEFLanguageCodes = {
	6514793: 'Китайская',
	6647399: 'Английская',
	6713957: 'Француская',
	6776178: 'Немецкая',
	6911073: 'Итальянская',
	6975598: 'Японская',
	7040882: 'Корейская',	
	7368562: 'Португальская',
	7501171: 'Русская',
	7565409: 'Испанская',
};

Player.SEFSetNextAudioStream = function () {

	if (this.tnum < 2) {
		Display.status('Недоступно!' );
		return;
	}
	var num = this.SefPlugin.Execute('GetCurrentStreamID', 1);
	if (num < 0) {
		Display.status('ОШИБКА открытия звуковой дорожки!');
		return;
	}
	num ++;
	if (num > (this.tnum - 1))
		num = 0;
	this.SEFSetAudioStream(num, 0);
};


Player.SEFSetAudioStream = function (num, t) {
	
	if (this.tnum > 1 && num > -1 && this.tnum > num) {
		this.SefPlugin.Execute('SetStreamID', 1, num);
		var info = this.SefPlugin.Execute('GetStreamLanguageInfo', 1, num);
		var lang = this.SEFLanguageCodes[info];
		if (lang == null)
			lang = 'Неизвестная';
		var i = 'Display.status("' + lang.toString() + ' звуковая дорожка №' + (num + 1).toString() + '")';
		setTimeout(i, t);
	} else
		setTimeout('Display.status("Не правильный № звукой дорожки!")', t);
};
